#include <bits/stdc++.h>
using namespace std;
const int MAXX = 1e3;

class Event {
    public:
    int type;
    int time;
    pair<int, int> who;
    
    Event(int _type, int _time, pair<int, int> _who = pair<int, int> ()):
        type(_type),
        time(_time),
        who(_who) 
        {}

    bool operator<(Event other) const  {
        if(time == other.time) 
            return type > other.type;
        return time < other.time;
    }
};

vector<int64_t> solveFast(vector<int> t, vector<int> p, int T) {
    
    int n = t.size();
    vector<Event> events;
    map<int, vector<int>> orders;
    map<int, vector<int64_t>> answers;

    for(int i = 0; i < n; ++i) {
        events.push_back(Event(0, t[i] + T));
        orders[p[i]].push_back(i);
        events.push_back(Event(1, t[i] - p[i], {p[i], t[i]}));
    }

    sort(events.begin(), events.end());
    vector<pair<int, int>> waiting;

    for(const auto& event : events) {
        if(event.type == 0) {
            auto client = *(waiting.begin());
            answers[client.first].push_back(event.time + client.first);
            waiting.erase(waiting.begin());
        } else {
            waiting.push_back(event.who);
            sort(waiting.begin(), waiting.end());
        }
    }
    
    vector<int64_t> sol(n, 0);

    for(auto elem : orders) { 
        int who = elem.first;
        for(int i = 0; i < int(orders[who].size()); ++i) {
            sol[orders[who][i]] = answers[who][i];
        }
    }
    
    return sol;
}

int main() {
    ifstream cin("ramen.in");
    ofstream cout("ramen.out");

    int n, T; cin >> n >> T;
    
    vector<int> t(n, 0), p(n, 0);    
    
    set<int> times;
    for(int i = 0; i < n; ++i) {
        cin >> t[i] >> p[i];
        times.insert(t[i]);
    }

    assert(int(times.size()) == n);
    
    vector<int64_t> sol = solveFast(t, p, T);

    for(int i = 0; i < n; ++i) {
        cout << sol[i] << "\n";
    }
}
